//archivo holamundo.h

//se definen las interfaces de las diferentes clases

//se define una constante para que no se incluya el archivo mas de una vez
#ifndef _HOLA_MUNDO_H_
#define _HOLA_MUNDO_H_

//si no estan definidas las constantes las definimos para trabajar con tipos de datos bool
#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

//esto es para los compiladores que soporten .h precompilados para disminuir el tiempo de compilacin
#include <wx/wxprec.h>

//si no estan soportados se utiliza wx.h
#ifndef WX_PRECOMP
#include <wx/wx.h>
#endif

//para que funcione con el compilador de Borland se define un pragma que es una opcin especifica del compilador.
#ifdef __BORLANDC__
#pragma hdrstop
#endif

//clase derivada de wxApp no se crea ninguna instancia de ella, de ello se encarga el framework
class MiAplicacion:public wxApp
{
	public:
	//mtodo que sirve de funcin main
	virtual bool OnInit();
};

//clase que se encarga de crear la ventana de la aplicacion, deriva de la clase wxFrame
class MiVentana:public wxFrame
{
	public:
	//se define el constructor
	//se definen tres parametros el titulo, la posicion y el tamao de la ventana
	//se definene como constantes para evitar ser editados y se pasan por referencia para evitar crear copias de ellos mismos cuando se instancie esta clase (para ahorrar memoria)
	MiVentana(const wxString& titulo, const wxPoint& posicion, const wxSize& tam);
	

	// se definen los metodos qu
	private:
	//maneja eventos al cerrar la ventana
	void OnQuit(wxCommandEvent& event);
	// maneja eventos acerca de
	void OnAbout(wxCommandEvent& event);
	//este metodo es una funcion virtual que hemos sobreescrito para mostrar un mensaje al cerrar la ventana (wxFrame ya contiene este metodo)
	void OnCloseWindow(wxCommandEvent& event);

	//declaramos la tabla de eventos, no se incluye punto y coma porque es una macro.(un trozo de codigo que ya incluye su propio punto y coma)  Se debe declarar dentro de la interfaz de la clase que maneja los eventos
	DECLARE_EVENT_TABLE()
};

#endif //fin de _HOLA_MUNDO_H_
